#ifndef RTC_H_
#define RTC_H_
#include "avr/io.h"
#include "avr/interrupt.h"
#include <stdint.h>
//#include "com\pccom.h"


// Teilwert fr Timer 0 ausrechnen
// Der Timer soll alle 1/4 sekunde durchlaufen --> 250ms
// dadurch knnen entprellzeiten bis zu 250ms genutzt werden.
// Die Zhlfrequenz muss also den Timer einmal von 0...255
// in 250ms betragen. --> 1024 Hz
// bei
#define Timer0Clock 32768
// Entspricht das einen Teiler von 32

#define Timer0Teiler 3

#define UsedTimer  TCNT0





//***************************************************
//WinAVR 3.4.3 setzt die Bitsetzbefehle sbi(),cbi() ins Assembler-Listing fr diese
//beiden #defines ein ! Also kein Grund Inline Assembler zu benutzen.
// wenn diese schon definiert, nicht nochmal machen
#ifndef sbi
#define sbi(portn, bitn) ((portn)|=(1<<(bitn)))
#endif
#ifndef cbi
#define cbi(portn, bitn) ((portn)&=~(1<<(bitn)))
#endif

//******************************************************
//Prototypen



//extern volatile uint8_t sek1_4;

#ifndef NOP
#define NOP() asm volatile ("nop" ::)
#endif


//Echtzeituhr zyklus
extern void realTime(void);


//RTC Starten
extern void InitRtc(void);

//Timer auslesen
extern uint16_t get_ticks( void );

//verzgerungen

//Verzgerung bis 250ms Starten auflsung ca1ms
extern void del_ms_start(uint8_t *data); 
//Verzgerung Abfragen
extern uint8_t del_ms_read(uint8_t *data, uint8_t value);

//Verzgerung bis 65000ms Starten auflsung ca1ms
extern void del_ms_big_start(uint16_t *data); 
//Verzgerung Abfragen
extern uint8_t del_ms_big_read(uint16_t *data, uint16_t value);

extern uint16_t getMin();


//******************************************************


//Comandos

//Neue Zeit Setzten
#define		StartNeuTime	1

//Zeit Abfragen
#define		GetTime			2

//Zeit Luft
#define		TimeIsRunning	3

//Zeit ist Abgelaufen
#define		TimeReady		4

//******************************************************






#endif /*RTC_H_*/
